﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace WebForms
{
    public partial class UserControl : System.Web.UI.UserControl
    {

        public string DefaultOperation { get; set; } = "+";

        protected List<Tuple<string, double>> History {
            get {
                return ViewState["History"] as List<Tuple<string, double>>;
            }
            set {
                ViewState["History"] = value;
            }
        }

        protected void Page_Init(object sender, EventArgs e)
        {

            List<ListItem> options = new List<ListItem>() {
                new ListItem("+", "+"),
                new ListItem("-", "-"),
                new ListItem("*", "*"),
                new ListItem("/", "/")
            };

            this.OperationSelect.DataSource = options;
            this.OperationSelect.DataBind();

            this.OperationSelect.SelectedValue = this.DefaultOperation;
        }



        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void ComputeBtn_Click(object sender, EventArgs e)
        {
            Page.Validate("gr1");
            if (Page.IsValid)
            {
                double val1 = double.Parse(this.Num1Txt.Text);
                double val2 = double.Parse(this.Num2Txt.Text);
                string operation = this.OperationSelect.SelectedValue;

                double result = 0;
                switch (operation)
                {
                    case "+":
                        result = val1 + val2;
                        break;
                    case "-":
                        result = val1 - val2;
                        break;
                    case "*":
                        result = val1 * val2;
                        break;
                    case "/":
                        result = val1 / val2;
                        break;
                }

                this.ResultTxt.Text = result.ToString();

                if (this.History == null) { this.History = new List<Tuple<string, double>>(); }
                this.History.Add(new Tuple<string, double>(val1 + operation + val2, result));

            }
        }
    }
}